#!/usr/bin/python

# Processes the results.txt file to sum the number of bounded
# intervals and calculate some metrics on the data

import sys

if len(sys.argv) < 2:
  print "Syntax: %s <results.txt>" % sys.argv[0]
  sys.exit(2)

filename = sys.argv[1]

print "                         ****** Results ******"
count_all_bounded = 0
count_all_total = 0
for line in [line.strip() for line in open(filename)]:
  [program, bounded, total] = line.split(":")
  count_all_bounded += int(bounded)
  count_all_total += int(total)
  print "%25s: %3d bounded, %3d total" % (program, int(bounded), int(total))

print "                    --------------------------"
print "%25s:  %3d / %3d (%5.1f%%)" % ("TOTAL", count_all_bounded, count_all_total, 100.0*count_all_bounded/count_all_total)
