#include "bench.h"
//#include <stdlib.h>
//#include <stdio.h>
//#include <string.h>

// Size of the "base" array
#define N 1000000

void quicksort(int lo, int hi, int base[])
{ 
  DUMPP(lo);
  DUMPP(hi);
  int i,j;
  int pivot,temp;
    
  if (lo<hi) {
    for (i=lo,j=hi,pivot=base[hi];i<j;) {
      DUMPL(i);
      DUMPL(j);
      while (i<hi && base[i]<=pivot) {
        DUMPL(i);
        i++;
      } DUMPE(i);
      while (j>lo && base[j]>=pivot) {
        DUMPL(j);
        j--;
      } DUMPE(j);
      if (i<j) { 
        // i, j already dumped after increment
        temp=base[i];
        base[i]=base[j];
        base[j]=temp;
      }
    } DUMPE(i);
    DUMPE(j);
    temp=base[i]; 
    base[i]=base[hi];
    base[hi]=temp;
    //NOTE: removed recursive calls
    //quicksort(lo,i-1,base);  quicksort(i+1,hi,base);
  }
}

int cmpint(const void * i, const void * j)
{
  int vi = *((int *) i);
  int vj = *((int *) j);
  if (vi == vj) return 0;
  if (vi < vj) return -1;
  return 1;
}

int main(int argc, char ** argv)
{
  int n, i;
  int * a, * b;
  int bench = 0;

  if (argc >= 2) n = atoi(argv[1]); else n = 1000000;
  if (argc >= 3) bench = 1;
  a = malloc(n * sizeof(int));
  b = malloc(n * sizeof(int));
  for (i = 0; i < n; i++) { 
    DUMPL(i);
    b[i] = a[i] = rand() & 0xFFFF;
  } DUMPE(i);
  quicksort(0, n - 1, a);
  if (!bench) {
    qsort(b, n, sizeof(int), cmpint);
    for (i = 0; i < n; i++) {
      DUMPL(i);
      if (a[i] != b[i]) { printf("Bug!\n"); return 2; }
    } DUMPE(i);
    printf("OK\n");
  }
  return 0;
}
