open BinPos
open BinInt
open Format
open ToString
open Errors
open CFG
open LatticeSignatures
open IntervalDomain
open CfgIterator
open Maps

let interval_to_string (itv : Interval.t) : string =
  Printf.sprintf "[%s,%s]" (zToString (Interval.min itv)) (zToString (Interval.max itv))

(* Returns None if the interval is Top *)
let opt_interval_to_string (itv : Interval.t) : string option =
  if itv = Interval.top then
    None
  else
    Some (Printf.sprintf "[%s,%s]" (zToString (Interval.min itv)) (zToString (Interval.max itv)))

let itvbot_to_string (itvb : Interval.itvbot) : string =
  match itvb with
    | Bot -> "Bot"
    | NotBot itv -> interval_to_string itv

(*
let pair_itv_mustvint_to_string (p : Interval.t * MustVInt.t) : string =
  match (snd p) with
    | MustVInt.Top -> "T"
    | MustVInt.VI -> interval_to_string (fst p)

let ($) = pair_itv_mustvint_to_string

type ab_t = (Interval.t * MustVInt.t) PTree.t option

let abToString (ab : ab_t) = (optionToString (pTreeToString ($)) ab)
*)
