open Camlcoq
open List0
open Maps
open RTL
open ValueAnalysis
open Utils

let check_map = ref Ptmap.empty
let stop_when_error = true

let check_fixpoint f fxp =
  if not (VarDomain.order VarDomain.top (PTree.get f.fn_entrypoint fxp)) 
  then failwith "check_fixpoint error at entrypoint";
  let _ = (forall_ptree
	     (fun n ins ->
		forallb
		  (fun x -> let (n', ab) = x in 
		     (if not (VarDomain.order ab (PTree.get n' fxp)) 
		     then 
		       if stop_when_error then assert false
		       else let n = Int32.to_int (camlint_of_positive n) in
			 check_map := 
			   Ptmap.add n
			     (Printf.sprintf "      Error at edge [%5l --> %5l]\n" n (Int32.to_int (camlint_of_positive n'))) !check_map);
		     true
		  )
		  (VarDomain.transfer f ins (PTree.get n fxp)))
	     f.fn_code) in
    true
	    
let go f =
  let fxp = extern_itv_analysis f in
  let fxp0 = extern2intern fxp in
  let _ = check_map := Ptmap.empty in
  let _ = check_fixpoint f fxp0 in
    (fun i -> try Ptmap.find i !check_map with Not_found -> "")

      
